Properties Methods Events Config Options Direct Link

    Observable
      TreeLoader

# Class Ext.tree.TreeLoader

Package: | Ext.tree
Defined In: | TreeLoader.js
Class: | TreeLoader
Extends: | Observable

A TreeLoader provides for lazy loading of an Ext.tree.TreeNode's child nodes from a specified URL. The response must be a JavaScript Array definition whose elements are node definition objects. e.g.:

    [{
            id: 1,
            text: 'A leaf Node',
            leaf: true
        },{
            id: 2,
            text: 'A folder Node',
            children: [{
                id: 3,
                text: 'A child Node',
                leaf: true
            }]
       }]

A server request is sent, and child nodes are loaded only when a node is expanded. The loading node's id is passed to the server under the parameter name "node" to enable the server to produce the correct child nodes.
To pass extra parameters, an event handler may be attached to the "beforeload" event, and the parameters specified in the TreeLoader's baseParams property:

    myTreeLoader.on("beforeload", function(treeLoader, node) {
            this.baseParams.category = node.attributes.category;
        }, this);

This would pass an HTTP parameter called "category" to the server containing the value of the Node's "category" attribute.

## Config Options

Config Options | Defined By
--- | ---
| baseAttrs : Object An object containing attributes to be added to all nodes created by this loader. If the attributes sent by the server... An object containing attributes to be added to all nodes created by this loader. If the attributes sent by the server have an attribute in this object, they take priority. | TreeLoader
| baseParams : Object An object containing properties which specify HTTP parameters to be passed to each request for child nodes. | TreeLoader
| clearOnLoad : Boolean Default to true. Remove previously existing child nodes before loading. | TreeLoader
| dataUrl : String The URL from which to request a Json string which specifies an array of node definition objects representing the chil... The URL from which to request a Json string which specifies an array of node definition objects representing the child nodes to be loaded. | TreeLoader
| directFn : Function Function to call when executing a request. | TreeLoader

listeners : Object
A config object containing one or more event handlers to be added to this object during initialization. This should ...

A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once.

DOM events from ExtJs Components

While some ExtJs Component classes export selected DOM events (e.g. "click", "mouseover" etc), this is usually only done when extra value can be added. For example the DataView's `click` event passing the node clicked on. To access DOM events directly from a Component's HTMLElement, listeners must be added to the Element after the Component has been rendered. A plugin can simplify this step:

    // Plugin is configured with a listeners config object.
    // The Component is appended to the argument list of all handler functions.
    Ext.DomObserver = Ext.extend(Object, {
        constructor: function(config) {
            this.listeners = config.listeners ? config.listeners : config;
        },

        // Component passes itself into plugin's init method
        init: function(c) {
            var p, l = this.listeners;
            for (p in l) {
                if (Ext.isFunction(l[p])) {
                    l[p] = this.createHandler(l[p], c);
                } else {
                    l[p].fn = this.createHandler(l[p].fn, c);
                }
            }

            // Add the listeners to the Element immediately following the render call
            c.render = c.render.createSequence(function() {
                var e = c.getEl();
                if (e) {
                    e.on(l);
                }
            });
        },

        createHandler: function(fn, c) {
            return function(e) {
                fn.call(this, e, c);
            };
        }
    });

    var combo = new Ext.form.ComboBox({

        // Collapse combo when its element is clicked on
        plugins: [ new Ext.DomObserver({
            click: function(evt, comp) {
                comp.collapse();
            }
        })],
        store: myStore,
        typeAhead: true,
        mode: 'local',
        triggerAction: 'all'
    });

Observable

| nodeParameter : String The name of the parameter sent to the server which contains the identifier of the node. Defaults to `'node'`. | TreeLoader

paramOrder : Array/String
Defaults to undefined. Only used when using directFn. Specifies the params in the order in which they must be passed ...
Defaults to `undefined`. Only used when using directFn. Specifies the params in the order in which they must be passed to the server-side Direct method as either (1) an Array of String values, or (2) a String of params delimited by either whitespace, comma, or pipe. For example, any of the following would be acceptable:

    nodeParameter: 'node',
    paramOrder: ['param1','param2','param3']
    paramOrder: 'node param1 param2 param3'
    paramOrder: 'param1,node,param2,param3'
    paramOrder: 'param1|param2|param|node'

TreeLoader

| paramsAsHash : Boolean Only used when using directFn. Send parameters as a collection of named arguments (defaults to false). Providing a pa... Only used when using directFn. Send parameters as a collection of named arguments (defaults to `false`). Providing a `paramOrder` nullifies this configuration. | TreeLoader
| preloadChildren : Boolean If set to true, the loader recursively loads "children" attributes when doing the first load on nodes. | TreeLoader
| requestMethod : String The HTTP request method for loading data (defaults to the value of Ext.Ajax.method). | TreeLoader

uiProviders : Object
An object containing properties which specify custom Ext.tree.TreeNodeUI implementations. If the optional uiProvider ...
An object containing properties which specify custom Ext.tree.TreeNodeUI implementations. If the optional uiProvider attribute of a returned child node is a string rather than a reference to a TreeNodeUI implementation, then that string value is used as a property name in the uiProviders object.

TreeLoader

| url : String Equivalent to dataUrl. | TreeLoader

## Public Properties

This class has no public properties.

## Public Methods

Method | Defined By
--- | ---

TreeLoader( `Object config` )
Creates a new Treeloader.
Creates a new Treeloader.
Parameters:

- `config` : Object
  A config object containing config properties.

Returns:

- void

TreeLoader

addEvents( `Object|String o`, `string Optional.` ) : void
Adds the specified events to the list of events which this Observable may fire.
Adds the specified events to the list of events which this Observable may fire.
Parameters:

- `o` : Object|String
  Either an object with event names as properties with a value of `true` or the first event name string if multiple event names are being passed as separate parameters.
- `Optional.` : string
  Event name if multiple event names are being passed as separate parameters. Usage:

      this.addEvents('storeloaded', 'storecleared');

Returns:

- void

Observable

addListener( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this object.
Appends an event handler to this object.
Parameters:

- `eventName` : String
  The name of the event to listen for.
- `handler` : Function
  The method the event invokes.
- `scope` : Object
  (optional) The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
- `options` : Object
  (optional) An object containing handler configuration. properties. This may contain any of the following properties:
  - scope : Object
    The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
  - delay : Number
    The number of milliseconds to delay the invocation of the handler after the event fires.
  - single : Boolean
    True to add a handler to handle just the next firing of the event, and then remove itself.
  - buffer : Number
    Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.
  - target : Observable
    Only call the handler if the event was fired on the target Observable, not if the event was bubbled up from a child Observable.

  Combining Options
  Using the options argument, it is possible to combine different types of listeners:
  A delayed, one-time listener.

      myDataView.on('click', this.onClick, this, {
      single: true,
      delay: 100
      });

  Attaching multiple handlers in 1 call
  The method also allows for a single argument to be passed which is a config object containing properties which specify multiple handlers.

      myGridPanel.on({
      'click' : {
          fn: this.onClick,
          scope: this,
          delay: 100
      },
      'mouseover' : {
          fn: this.onMouseOver,
          scope: this
      },
      'mouseout' : {
          fn: this.onMouseOut,
          scope: this
      }
      });

  Or a shorthand syntax:

      myGridPanel.on({
      'click' : this.onClick,
      'mouseover' : this.onMouseOver,
      'mouseout' : this.onMouseOut,
       scope: this
      });

Returns:

- void

Observable

createNode( `attr {Object}` ) : void
Override this function for custom TreeNode node implementation, or to modify the attributes at creation time. Example...

Override this function for custom TreeNode node implementation, or to modify the attributes at creation time.

Example:

    new Ext.tree.TreePanel({
        ...
        loader: new Ext.tree.TreeLoader({
            url: 'dataUrl',
            createNode: function(attr) {
    //          Allow consolidation consignments to have
    //          consignments dropped into them.
                if (attr.isConsolidation) {
                    attr.iconCls = 'x-consol',
                    attr.allowDrop = true;
                }
                return Ext.tree.TreeLoader.prototype.createNode.call(this, attr);
            }
        }),
        ...
    });

Parameters:

- `{Object}` : attr
  The attributes from which to create the new node.

Returns:

- void

TreeLoader

enableBubble( `String/Array events` ) : void
Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if present....

Enables events fired by this Observable to bubble up an owner hierarchy by calling `this.getBubbleTarget()` if present. There is no implementation in the Observable base class.

This is commonly used by Ext.Components to bubble events to owner Containers. See Ext.Component.getBubbleTarget. The default implementation in Ext.Component returns the Component's immediate owner. But if a known target is required, this can be overridden to access the required target more quickly.

Example:

    Ext.override(Ext.form.Field, {
        //  Add functionality to Field's initComponent to enable the change event to bubble
        initComponent : Ext.form.Field.prototype.initComponent.createSequence(function() {
            this.enableBubble('change');
        }),

        //  We know that we want Field's events to bubble directly to the FormPanel.
        getBubbleTarget : function() {
            if (!this.formPanel) {
                this.formPanel = this.findParentByType('form');
            }
            return this.formPanel;
        }
    });

    var myForm = new Ext.formPanel({
        title: 'User Details',
        items: [{
            ...
        }],
        listeners: {
            change: function() {
                // Title goes red if form has been modified.
                myForm.header.setStyle('color', 'red');
            }
        }
    });

Parameters:

- `events` : String/Array
  The event name to bubble, or an Array of event names.

Returns:

- void

Observable

fireEvent( `String eventName`, `Object... args` ) : Boolean
Fires the specified event with the passed parameters (minus the event name). An event may be set to bubble up an Obse...

Fires the specified event with the passed parameters (minus the event name).

An event may be set to bubble up an Observable parent hierarchy (See Ext.Component.getBubbleTarget) by calling enableBubble.

Parameters:

- `eventName` : String
  The name of the event to fire.
- `args` : Object...
  Variable number of parameters are passed to handlers.

Returns:

- `Boolean`
  returns false if any of the handlers return false otherwise it returns true.

Observable

hasListener( `String eventName` ) : Boolean
Checks to see if this object has any listeners for a specified event
Checks to see if this object has any listeners for a specified event
Parameters:

- `eventName` : String
  The name of the event to check for

Returns:

- `Boolean`
  True if the event is being listened for, else false

Observable

load( `Ext.tree.TreeNode node`, `Function callback`, `Object scope` ) : void
Load an Ext.tree.TreeNode from the URL specified in the constructor. This is called automatically when a node is expa...
Load an Ext.tree.TreeNode from the URL specified in the constructor. This is called automatically when a node is expanded, but may be used to reload a node (or append new children if the clearOnLoad option is false.)
Parameters:

- `node` : Ext.tree.TreeNode
- `callback` : Function
  Function to call after the node has been loaded. The function is passed the TreeNode which was requested to be loaded.
- `scope` : Object
  The scope (`this` reference) in which the callback is executed. defaults to the loaded TreeNode.

Returns:

- void

TreeLoader

on( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this object (shorthand for addListener.)
Appends an event handler to this object (shorthand for addListener.)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
- `options` : Object
  (optional) An object containing handler configuration.

Returns:

- void

Observable

purgeListeners() : void
Removes all listeners for this object
Removes all listeners for this object
Parameters:

- None.

Returns:

- void

Observable

relayEvents( `Object o`, `Array events` ) : void
Relays selected events from the specified Observable as if the events were fired by this.
Relays selected events from the specified Observable as if the events were fired by `this`.
Parameters:

- `o` : Object
  The Observable whose events this object is to relay.
- `events` : Array
  Array of event names to relay.

Returns:

- void

Observable

removeListener( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes an event handler.
Removes an event handler.
Parameters:

- `eventName` : String
  The type of event the handler was associated with.
- `handler` : Function
  The handler to remove. This must be a reference to the function passed into the addListener call.
- `scope` : Object
  (optional) The scope originally specified for the handler.

Returns:

- void

Observable

resumeEvents() : void
Resume firing events. (see suspendEvents) If events were suspended using the queueSuspended parameter, then all event...
Resume firing events. (see suspendEvents) If events were suspended using the `queueSuspended` parameter, then all events fired during event suspension will be sent to any listeners now.
Parameters:

- None.

Returns:

- void

Observable

suspendEvents( `Boolean queueSuspended` ) : void
Suspend the firing of all events. (see resumeEvents)
Suspend the firing of all events. (see resumeEvents)
Parameters:

- `queueSuspended` : Boolean
  Pass as true to queue up suspended events to be fired after the resumeEvents call instead of discarding all suspended events;

Returns:

- void

Observable

un( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes an event handler (shorthand for removeListener.)
Removes an event handler (shorthand for removeListener.)
Parameters:

- `eventName` : String
  The type of event the handler was associated with.
- `handler` : Function
  The handler to remove. This must be a reference to the function passed into the addListener call.
- `scope` : Object
  (optional) The scope originally specified for the handler.

Returns:

- void

Observable

## Public Events

Event | Defined By
--- | ---

beforeload : ( `Object This`, `Object node`, `Object callback` )
Fires before a network request is made to retrieve the Json text which specifies a node's children.
Fires before a network request is made to retrieve the Json text which specifies a node's children.
Listeners will be called with the following arguments:

- `This` : Object
  TreeLoader object.
- `node` : Object
  The Ext.tree.TreeNode object being loaded.
- `callback` : Object
  The callback function specified in the load call.

TreeLoader

load : ( `Object This`, `Object node`, `Object response` )
Fires when the node has been successfuly loaded.
Fires when the node has been successfuly loaded.
Listeners will be called with the following arguments:

- `This` : Object
  TreeLoader object.
- `node` : Object
  The Ext.tree.TreeNode object being loaded.
- `response` : Object
  The response object containing the data from the server.

TreeLoader

loadexception : ( `Object This`, `Object node`, `Object response` )
Fires if the network request failed.
Fires if the network request failed.
Listeners will be called with the following arguments:

- `This` : Object
  TreeLoader object.
- `node` : Object
  The Ext.tree.TreeNode object being loaded.
- `response` : Object
  The response object containing the data from the server.

TreeLoader